# IpsecConnectorSpec

An IPsec Connector Specification.  The configuration of a connector uses an inheritance model so that connections within a connector can re-use the common configuration of the connector.  Should a specific connection require overriding specific attributes of the connection, each connection has its own config section that allows this override.  Each connection has a name that must be configured to instantiate a connection. A connection can be created by a PUT to the  connector endpoint. 
## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**name** | **str** | The name of the IPsec connector  | 
**name_slug** | **str** | A human readable slug to identify a resource and that is rfc1035 label compliant. The length has been restricted to 20 characters such that this name can be concatenated with other names or slugs. A slug is readOnly as it is generated by the backend resource.  | [optional] 
**org_id** | **str** | Unique identifier | 
**ipsec_gateway_id** | **str** | The GUID of the IpsecGateway where this connector is instantiated from. | [optional] 
**connections** | [**list[IpsecConnection]**](IpsecConnection.md) | Defines the set of IPsec connections within the connector. Adding an IpsecConnection(s) here will instantiate the connection(s). Removing an IpsecConnection(s) here cause the connection(s) to be torn down.  | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


